#line 1 "D:/PIC_Programming/PIC16F88/AD9059/AD9059.c"
#line 13 "D:/PIC_Programming/PIC16F88/AD9059/AD9059.c"
sbit Soft_I2C_Scl at RB4_bit;
sbit Soft_I2C_Sda at RB1_bit;
sbit Soft_I2C_Scl_Direction at TRISB4_bit;
sbit Soft_I2C_Sda_Direction at TRISB1_bit;





int freq_index = 0;

void Config(){
 OSCCON = 0b01110010;


 PORTA = 0b00000000;
 ANSEL = 0b00000000;
 TRISA = 0b00000011;


 PORTB = 0b00000000;
 TRISB = 0b00100000;


 OPTION_REG = 0b00000000;
 INTCON = 0b00000000;

}

void set_frequency_b(unsigned int freq){
  PORTB.F2  = 1;


 Soft_I2C_Start();
 Soft_I2C_Write( 0b00101110 );
 Soft_I2C_Write( ((char *)&freq)[1] );
 Soft_I2C_Write( ((char *)&freq)[0] );
 Soft_I2C_Stop();

 delay_ms(300);
  PORTB.F2  = 0;
}

void set_frequency(unsigned int OCT, unsigned long l_freq){
 unsigned int DAC = 0;
 unsigned int freq = 0;

 DAC = 2048 - 2078 * pow(2, 10 + OCT) / l_freq;
 DAC = DAC & 0x3FF;

 freq = (OCT << 12) | (DAC << 2);

 set_frequency_b(freq);
}

void main() {
 unsigned char send_data = 1;
 Config();

  PORTB.F2  = 0;

 Soft_I2C_Init();
 Delay_ms(500);
 freq_index = 0;

 do{
 if( PORTA.F0  == 0) {
  PORTB.F2  = 1;
 if(freq_index < 12) freq_index++;
 send_data = 1;

 delay_ms(500);
  PORTB.F2  = 0;

 while( PORTA.F0  == 0);
 }

 if( PORTA.F1  == 0) {
  PORTB.F2  = 1;
 if(freq_index > 0) freq_index--;
 send_data = 1;

 delay_ms(500);
  PORTB.F2  = 0;

 while( PORTA.F1  == 0);
 }

 if( PORTB.F5  == 0) {
  PORTB.F2  = 1;
 send_data = 1;

 delay_ms(500);
  PORTB.F2  = 0;

 while( PORTB.F5  == 0);
 }

 if(send_data) {
 switch(freq_index) {
 case 0: set_frequency(3, 10000UL); break;
 case 1: set_frequency(5, 50000UL); break;
 case 2: set_frequency(6, 100000UL); break;
 case 3: set_frequency(8, 500000UL); break;
 case 4: set_frequency(9, 1000000UL); break;
 case 5: set_frequency(10, 2000000UL); break;
 case 6: set_frequency(12, 5000000UL); break;
 case 7: set_frequency(13, 10000000UL); break;
 case 8: set_frequency(14, 20000000UL); break;
 case 9: set_frequency(14, 30000000UL); break;
 case 10: set_frequency(15, 40000000UL); break;
 case 11: set_frequency(15, 50000000UL); break;
 case 12: set_frequency(15, 60000000UL); break;
 default: set_frequency(0, 2000UL); break;
 }
 }

 send_data = 0;
 } while(1);
}
